Page MenuHomePhabricator

A lot of functionality in Phabricator is missing / not working when JavaScript is off in the browser
Closed, DeclinedPublic

Description

There is a serious accessibility problem in Phabricator.

Safari Mac, with JavaScript off.
I go to Phabricator.
I try to use Phabricator...

Expected result:

Phabricator works. I can do the things in Phabricator.

Observed result:

Phabricator is crippled. Many things are impossible to do in Phabricator.

Here are some examples of broken things:

  1. When creating a task, putting a tag is impossible.
  2. On the home page of Phabricator, many panels show "Loading..." without end instead of the expected content. This is misleading; this entices the person to wait during eternity [and "eternity is long, especially near the end"]; in fact, the panels are not loading anything.
  3. On a task, the "older changes" are inaccessible.

It would be very nice to correct that.

Thank you.

Event Timeline

Nnemo created this task.Oct 2 2016, 8:59 AM
Restricted Application added a subscriber: Aklapper. · View Herald TranscriptOct 2 2016, 8:59 AM
Nnemo awarded a token.Oct 2 2016, 8:59 AM
Nnemo added projects: Phabricator, Accessibility.
Restricted Application added a subscriber: TerraCodes. · View Herald TranscriptOct 2 2016, 9:00 AM
Nnemo added a comment.Oct 2 2016, 9:19 AM
  1. When creating a task, the "Description preview" shows no preview but shows "Loading preview..." without end. So here too we get the problems of the example 2.
Aklapper renamed this task from Phabricator is crippled, when JavaScript is off to A lot of functionality in Phabricator is missing / not working when JavaScript is off in the browser.Oct 4 2016, 11:41 AM
Aklapper triaged this task as Low priority.
Aklapper edited projects, added Phabricator (Upstream); removed Phabricator.
Restricted Application added a project: Upstream. · View Herald TranscriptOct 4 2016, 11:41 AM

Is there any reason you are viewing without javascript being enabled?

These are upstream issues with the phabricator package that should be filed in their tracker which can be found at https://secure.phabricator.com/, Although I don't know what level of support they provide to browser clients without javascript.

I neither see upstream maintainers support non-JS browsers nor do I see us maintaining custom changes to support non-JS browsers...

I'd also love to hear compelling reasons why to use non-JS browsers (as technology to block certain content often exists, e.g. "NoScript" add-ons/extensions).

Josve05a edited projects, added JavaScript; removed Accessibility.Oct 5 2016, 12:26 AM

I've had to use Phabricator without JS on poor connections a couple of times, where the JavaScript just wouldn't load no matter how long I waited.

Most bits of Phabricator work fairly well without JavaScript, although the fact that all of the form fields with autocomplete functionality don't work at all without it is a pain. (It used to be that you could add projects by mentioning them in the task description, like #accessibility, but this was changed at some point.)

For MediaWiki we take non-JS functionality seriously because we want "anyone can edit" to really be true, and also out of certain sense of professional pride in well-made software ;) Upstream they don't have a slogan about anyone being able to file tasks, but their professional pride also runs high, so I think they'd at least hear you out.

Nnemo added a comment.Oct 23 2016, 1:54 AM

Is there any reason you are viewing without javascript being enabled?

Usually, yes. And, usually, this is related to Web sites other than Phabricator. Some Web sites are very impolite these days.

Nnemo added a comment.Oct 23 2016, 2:55 AM

@Peachey88 @Aklapper

Some Web sites are very impolite these days. Sounds (sometimes in loop!), videos, crazy auto-reloads, eating the perfs of the computer, the fan roaring…

@Peachey88 @Aklapper

Some Web sites are very impolite these days.

We never said they weren't, But we are only discussing usage of our Phabricator instance (and the
upstream package) here in this task.

Since JavaScript is a client side matter, We can't tell when you change JS mode mid-usage, where as we can do optional stuff on the load.

If your browser (or a addon, for example) allows you easily disable features (such as javascript) and doesn't tell you the consequences that can occur (for example, websites suddenly breaking), then that is a task for those provides (and their relevant task trackers).

Usually, yes. And, usually, this is related to Web sites other than Phabricator.

Then you can set up different settings for those other web sites but not for Phabricator.

I don't see good reasons provided yet why to generally switch off JS, or JS on Wikimedia Phabricator. And those reasons need to be around first, to understand the root problem.

Aklapper lowered the priority of this task from Low to Lowest.Nov 7 2016, 11:13 PM
EddieGP closed this task as Declined.Jan 6 2018, 11:08 PM
EddieGP added a subscriber: EddieGP.

I've just tried to use phabricator without js, noticed it's horribly broken and found this task as well as a few upstream requesting this-and-that should be working without js enabled. Unfortunately upstream won't support non-js:

We do not support disabling Javascript and have no plans to improve Phabricator for users who intentionally disable Javascript. These users should enable Javascript if they want to use Phabricator.

As Andre already mentioned above, Wikimedia won't have a ton of custom patches created, applied and supported to our local phabricator instance (it'd require a lot of dedicated resources of some WMF team to implement it in the first place, and ongoing resources to maintain it afterwards).

It's not that it'd be an especially bad thing to have non-js support, but as it stands, that's just not going to happen. Hence I'm being bold and declining this.